/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package vostokclasslibsample;

import java.io.File;
import java.io.IOException;
import org.vostok.lang.classes.ClassFinder;
import org.vostok.lang.classes.DynamicClassLoader;
import org.vostok.lang.classes.NotADirectoryException;
import vostokclasslibsample.sample.DummyInterface;
import vostokclasslibsample.sample.MyInterface;
import vostokclasslibsample.sample.SampleAbstractClass;
import vostokclasslibsample.sample.SampleInterface;

/**
 *
 * @author levreau.jerome@vostoksystem.eu
 */
public class TestClass {

	/**
	 * @param args the command line arguments
	 */
	public static void main(String[] args) throws IOException, NotADirectoryException, ClassNotFoundException, InstantiationException, IllegalAccessException {

		System.out.println("\n\n---------------- VostokClassLib sample ------------------");



		System.out.println("looking for class implementing " + SampleInterface.class.getCanonicalName() + "\n");
		Class[] res = new ClassFinder(ClassLoader.getSystemClassLoader(), true).whoImplement(SampleInterface.class);
		if (res.length == 0) {
			System.out.println("\n no match found...");
		} else {
			for (Class c : res) {
				System.out.println("class : " + c.getCanonicalName());
			}
		}

		System.out.println("\n\n---------------");
		System.out.println("looking for class extending " + SampleAbstractClass.class.getCanonicalName() + "\n");
		res = new ClassFinder(ClassLoader.getSystemClassLoader(), true).whoImplement(SampleAbstractClass.class);
		if (res.length == 0) {
			System.out.println("\n no match found...");
		} else {
			for (Class c : res) {
				System.out.println("class : " + c.getCanonicalName());
			}
		}

		System.out.println("\n\n---------------");
		System.out.println("looking for class implementing " + DummyInterface.class.getCanonicalName() + "\n");
		res = new ClassFinder(ClassLoader.getSystemClassLoader(), true).whoImplement(DummyInterface.class);
		if (res.length == 0) {
			System.out.println("\n no match found... (whish is the correct answer)");
		} else {
			for (Class c : res) {
				System.out.println("class : " + c.getCanonicalName());
			}
		}

		System.out.println("\n\n---------------");
		String tmpd = System.getProperty("java.io.tmpdir");

		System.out.println("Dynamically load class. In order to success, you must put VostokClassLibSampleTarget.jar into the temp dir (" + tmpd + ")");

		DynamicClassLoader dcl = DynamicClassLoader.newInstance(new File(tmpd));

		String[] list = dcl.whoImplement(MyInterface.class);
		if (list.length == 0) {
			System.out.println("\n no match found...");

		} else {
			System.out.println("Create new instance from first answer : " + list[0]);

			MyInterface my = dcl.newObjectInstance(MyInterface.class, list[0]);

			System.out.println("calling method \"ping\" : " + my.ping("Hello word.."));

			System.out.println("\n\n---------------");
			System.out.println("looking whose is implementing vostokclasslibsampletarget.MyClass but with string, not class");
			list = dcl.whoImplement("vostokclasslibsampletarget.MyClass");

			if (list.length == 0) {
				System.out.println("\n no match found...");
			} else {
				for (String s : list) {
					System.out.println("class : " + s);
				}
			}
		}

		System.out.println("\nEnd...");
	}
}
